The Generic Mapping Tools

Version 4.5.13

A Map-making Tutorial

by

Pål (Paul) Wessel

School of Ocean and Earth Science and Technology

University of Hawai’i at Mānoa

and

Walter H. F. Smith

Laboratory for Satellite Altimetry

NOAA/NESDIS

July 2014

## Contents

Front page
INTRODUCTION
GMT overview: History, philosophy, and usage
Historical highlights
Philosophy
Why is GMT so popular?
GMT installation considerations
1 SESSION ONE
1.1 Tutorial setup
1.2 The GMT environment: What happens when you run GMT?
1.2.1 Input data
1.2.2 Job Control
1.2.3 Output data
1.3 The UNIX Environment: Entry Level Knowledge
1.3.1 Redirection
1.3.2 Piping (|)
1.3.3 Standard error (stderr)
1.3.4 File name expansion or “wild cards”
1.4 Laboratory Exercises
1.4.1 Linear projection
1.4.2 Logarithmic projection
1.4.3 Mercator projection
1.4.4 Albers projection
1.4.5 Orthographic projection
1.4.6 Eckert IV and VI projection
2 SESSION TWO
2.1 General Information
2.1.1 Examples
2.1.2 Exercises
2.1.3 More exercises
2.2 Plotting text strings
2.3 Exercises
3 SESSION THREE
3.1 Contouring gridded data sets
3.1.1 Exercises
3.2 Gridding of arbitrarily spaced data
3.2.1 Nearest neighbor gridding
3.2.2 Gridding with Splines in Tension
3.2.3 Preprocessing
3.3 Exercises
4 SESSION FOUR
4.1 Cpt files
4.1.1 Exercises
4.2 Illumination and intensities
4.3 Color images
4.3.1 Exercises
4.4 Multi-dimensional maps
4.4.1 Exercises
4.5 Perspective views
4.5.1 Mesh-plot
4.5.2 Color-coded view
5 References

## INTRODUCTION

The purpose of this tutorial is to introduce new users to GMT, outline the GMT environment, and enable you to make several forms of graphics without having to know too much about UNIX and UNIX tools. We will not be able to cover all aspects of GMT nor will we necessarily cover the selected topics in sufficient detail. Nevertheless, it is hoped that the exposure will prompt the users to improve their GMT and UNIX skills after completion of this short tutorial.

### GMT overview: History, philosophy, and usage

#### Historical highlights

The GMT system was initiated in late 1987 at Lamont-Doherty Earth Observatory, Columbia University by graduate students Paul Wessel and Walter H. F. Smith. Version 1 was officially introduced to Lamont scientists in July 1988. GMT 1 migrated by word of mouth (and tape) to other institutions in the United States, UK, Japan, and France and attracted a small following. Paul took a Post-doctoral position at SOEST in December 1989 and continued the GMT development. Version 2.0 was released with an article in EOS, October 1991, and quickly spread worldwide. We obtained NSF-funding for GMT version 3.0 in 1993 which was released with another article in EOS on August 15, 1995. Significantly improved versions (3.1-3.3, 3.3.1–6), 3.4, 3.4.1–5, and 4.0–4.5.11 were released between November 1998 and November 2013, culminating in the July 2014 introduction of 4.5.13. GMT now is used by ten thousands of users worldwide in a broad range of disciplines.

#### Philosophy

GMT follows the UNIX philosophy in which complex tasks are broken down into smaller and more manageable components. Individual GMT modules are small, easy to maintain, and can be used as any other UNIX tool. GMT is written in the ANSI C programming language (very portable), is POSIX compliant, and is independent of hardware constraints (e.g., memory). GMT was deliberately written for command-line usage, not a windows environment, in order to maximize flexibility. We standardized early on to use PostScript output instead of other graphics formats. Apart from the built-in support for coastlines, GMT completely decouples data retrieval from the main GMT programs. GMT uses architecture-independent file formats.

#### Why is GMT so popular?

The price is right! Also, GMT offers unlimited flexibility since it can be called from the command line, inside scripts, and from user programs. GMT has attracted many users because of its high quality PostScript output. GMT easily installs on almost any computer.

#### GMT installation considerations

GMT has been installed on machines ranging from super-computers to lap-top PCs. GMT only contains some 100,000 lines of code and has modest space/memory requirements. Minimum requirements are

- The netCDF library 3.4 or higher (free from www.unidata.edu).
- A C Compiler (free from www.gnu.org).
- About 100 Mb disk space (70 Mb additional for full- and high-resolution coast-lines).
- About 32 Mb memory.

In addition, we recommend access to a PostScript printer or equivalent (e.g., ghostscript), PostScript previewer (e.g., gv (ghostview)), any flavor of the UNIX operating system, and more disk space and memory.

## Chapter 1
SESSION ONE

### 1.1 Tutorial setup

1. We assume that GMT has been properly and fully installed and that the GMT executables are in your executable path described in the GMT README file.
2. All GMT man pages, documentation, and example scripts are available from the GMT documentation web page. It is assumed these pages have been installed locally at your site; if not they are always available from the main GMT home page.
3. We recommend you create a sub-directory called tutorial, cd into that directory, and copy all the tutorial files directly there. Depending on your installation the tutorial files are likely in /usr/share/doc/gmt/tutorial.
4. As we discuss GMT principles it may be a good idea to consult the GMT Technical Reference and Cookbook for more detailed explanations.
5. The tutorial uses the supplemental GMT program grdraster to extract subsets of global gridded data sets. For your convenience we also supply the subsets in the event you do not wish to install grdraster and the public data sets it can read. Thus, run the grdraster commands if you have made the installation or ignore them if you have not.
6. For all but the simplest GMT jobs it is recommended that you place all the GMT (and UNIX) commands in a shell script file and make it executable. To ensure that UNIX recognizes your script as a shell script it is a good habit always to start the script with the line #!/bin/sh or #!/bin/csh, depending on the shell you prefer to use. All the examples in this tutorial assumes you are running the Bourne shell, sh; if you are using something different then you are on your own.
7. Making a script executable is accomplished using the chmod command, e.g., the script figure_1.sh is made executable with “chmod +x figure_1.sh”.
8. To view a PostScript file (e.g., map.ps) on a UNIX workstation we use gv map.ps. On some systems there will be similar commands, like imagetool and pageview on Sun workstations. In this text we will refer to gv; please substitute the relevant PostScript previewer on your system.
9. Please cd into the directory tutorial. We are now ready to start.

### 1.2 The GMT environment: What happens when you run GMT?

To get a good grasp on GMT one must understand what is going on “under the hood”. Figure 1.1 illustrates the relationships you need to be aware of at run-time.

Figure 1.1: The GMT run-time environment.

#### 1.2.1 Input data

A GMT program may or may not take input files. Three different types of input are recognized (more details can be found in Appendix B in the Technical Reference):

1. Data tables. These are “spreadsheet” tables with a fixed number of columns and unlimited number of rows. We distinguish between two groups:
   - ASCII (Preferred unless files are huge)
     –
       Single segment [Default]
     –
       Multi-segment with internal header records (–M)
   - Binary (to speed up input/output)
     –
       Single segment [Default]
     –
       Multi-segment (segment headers are all NaN fields) (–M)
2. Gridded dated sets. These are data matrices (evenly spaced in two coordinates) that come in two flavors:
   - Grid-line registration
   - Pixel registration

   You may choose among several file formats (even define your own format), but the GMT default is the architecture-indenpendent netCDF format.

3. Color palette table (For imaging, color plots, and contour maps). We will discuss these later.

#### 1.2.2 Job Control

GMT programs may get operational parameters from several places:

1. Supplied command line options/switches or program defaults.
2. Short-hand notation to select previously used option arguments (stored in .gmtcommands4).
3. Implicitly using GMT defaults for a variety of parameters (stored in .gmtdefaults4).
4. May use hidden support data like coastlines or PostScript patterns.

#### 1.2.3 Output data

There are 6 general categories of output produced by GMT:

1. PostScript plot commands.
2. Data Table(s).
3. Gridded data set(s).
4. Statistics & Summaries.
5. Warnings and Errors, written to stderr.
6. Exit status (0 means success, otherwise failure).

Note: GMT automatically creates and updates a history of past GMT command options for the common switches. This history file is called .gmtcommands and one will be created in every directory from which GMT programs are executed. Many initial problems with GMT usage result from not fully appreciating the relationships shown in Figure 1.1.

### 1.3 The UNIX Environment: Entry Level Knowledge

#### 1.3.1 Redirection

Most GMT programs read their input from the terminal (called stdin) or from files, and write their output to the terminal (called stdout). To use files instead one can use UNIX redirection:

GMTprogram input-file > output-file
GMTprogram < input-file > output-file
GMTprogram input-file >> output-file # Append to existing file

In this example, and in all those to follow, it is assumed that you do not have the shell variable noclobber set. If you do, it prevents accidental overwriting of existing files. That may be a noble cause, but it is extremely annoying. So please, unset noclobber.

#### 1.3.2 Piping (|)

Sometimes we want to use the output from one program as input to another program. This is achieved with UNIX pipes:

Someprogram | GMTprogram1 | GMTprogram2 > Output-file (or | lp)

#### 1.3.3 Standard error (stderr)

Most UNIX and GMT programs will on occasion write error messages. These are typically written to a separate data stream called stderr and can be redirected separately from the standard output (which goes to stdout). To send the error messages to the same location as standard output we use

UNIXprogram > errors.log 2>&1

When we want to save both program output and error messages to separate files we use the following syntax:

GMTprogram > output.d 2> errors.log

#### 1.3.4 File name expansion or “wild cards”

UNIX provides several ways to select groups of files based on name patterns (Table 1.1):

Code | Meaning

* | Matches anything

? | Matches any single character

[list] | Matches characters in the list

[range] | Matches characters in the given range

Table 1.1: UNIX wildcards.

You can save much time by getting into the habit of selecting “good” filenames that make it easy to select subsets of all files using the UNIX wild card notation.

##### Examples

- GMTprogram data_*.d operates on all files starting with “data_” and ending in “.d”.
- GMTprogram line_?.d works on all files starting with “line_” followed by any single character and ending in “.d”.
- GMTprogram section_1[0-9]0.part_[12] only processes data from sections 100 through 190, only using every 10th profile, and gets both part 1 and 2.

### 1.4 Laboratory Exercises

We will begin our adventure by making some simple plot axes and coastline basemaps. We will do this in order to introduce the all-important -B, -J, and -R switches and to familiarize ourselves with a few selected GMT projections. The GMT programs we will utilize are psbasemap and pscoast. Please consult their manual pages on the GMT web site for reference.

#### 1.4.1 Linear projection

We start by making the basemap frame for a linear x-y plot. We want it to go from 10 to 70 in x, annotating every 10, and from -3 to 8 in y, annotating every 1. The final plot should be 4 by 3 inches in size. Here’s how we do it:

psbasemap -R10/70/-3/8 -JX4i/3i -B10/1:.~My first plot~: -P > plot.ps

You can view the result with gv plot.ps.

##### Exercises

1. Try change the -JX values.
2. Try change the -B values.
3. Omit the -P.

#### 1.4.2 Logarithmic projection

We next will show how to do a basemap for a log–log plot. We will assume that the raw x data range from 3 to 9613 and y ranges from 3.2⋅1 020 to 6.8⋅1 024. One possibility is

psbasemap -R1/10000/1e20/1e25 -JX9il/6il \
-B2:~Wavelength (m)~:/a1pf3:~Power (W)~:WS > plot.ps

(The backslash \ makes UNIX ignore the carriage return that follows and treat the two lines as one long command).

##### Exercises

1. Do not append l to the axes lengths.
2. Leave the p modifier out of the -B string.
3. Add g3 to each side of the slash in -B.

#### 1.4.3 Mercator projection

Despite the problems of extreme horizontal exaggeration at high latitudes, the conformal Mercator projection (-JM) remains the stalwart of location maps used by scientists. It is one of several cylindrical projections offered by GMT; here we will only have time to focus on one such projection. The complete syntax is simply

-JMwidth

To make coastline maps we use pscoast which automatically will access the GMT coastline, river and border data base derived from the GSHHG database1. In addition to the common switches we may need to use some of several pscoast -specific options (see Table 1.2).

Option | Purpose

-A | Exclude small features or those of high hierarchical levels (see Appendix K)

-D | Select data resolution (full, high, intermediate, low, or crude)

-G | Set color of dry areas (default does not paint)

-I | Draw rivers (chose features from one or more hierarchical categories)

-L | Plot map scale (length scale can be km, miles, or nautical miles)

-N | Draw political borders (including US state borders)

-S | Set color for wet areas (default does not paint)

-W | Draw coastlines and set pen thickness

Table 1.2: Main options when making coastline plots or overlays.

One of -W, -G, -S must be selected. Our first coastline example is from Latin America:

pscoast -R-90/-70/0/20 -JM6i -P -B5g5 -Gchocolate > map.ps

##### Exercises

1. Add the -V option.
2. Try -R270/290/0/20 instead. What happens to the annotations?
3. Edit your .gmtdefaults4 file, change PLOT_DEGREE_FORMAT to another setting (see the gmtdefaults man page), and plot again.
4. Pick another region and change land color.
5. Pick a region that includes the north or south poles.
6. Try -W0.25p instead of (or in addition to) -G.

#### 1.4.4 Albers projection

The Albers projection (-JB) is an equal-area conical projection; its conformal cousin is the Lambert conic projection (-JL). Their usages are almost identical so we will only use the Albers here. The general syntax is

-JB lo n0∕la t0∕la t1∕la t2∕width

where (lo n0,la t0) is the map (projection) center and la t1,la t2 are the two standard parallels where the cone intersects the Earth’s surface. We try the following command:

pscoast -R-130/-70/24/52 -JB-100/35/33/45/6i -B10g5:.~Conic Projection~: \
-N1/thickest -N2/thinnest -A500 -Ggray -Wthinnest -P > map.ps

##### Exercises

1. Change the parameter GRID_CROSS_SIZE_PRIMARY to make grid crosses instead of gridlines.
2. Change -R to a rectangular box specification instead of minimum and maximum values.

#### 1.4.5 Orthographic projection

The azimuthal orthographic projection (-JG) is one of several projections with similar syntax and behavior; the one we have chosen mimics viewing the Earth from space at an infinite distance; it is neither conformal nor equal-area. The syntax for this projection is

-JG lo n0∕la t0∕width

where (lo n0,la t0) is the center of the map (projection). As an example we will try

pscoast -R0/360/-90/90 -JG280/30/6i -Bg30/g15 -Dc -A5000 -Gwhite \
-SDarkTurquoise -P > map.ps

##### Exercises

1. Use the rectangular option in -R to make a rectangular map showing the US only.

#### 1.4.6 Eckert IV and VI projection

We conclude the survey of map projections with the Eckert IV and VI projections (-JK), two of several projections used for global thematic maps; They are both equal-area projections whose syntax is

-JK[f|s]lo n0∕width

where f gives Eckert IV (4) and s (Default) gives Eckert VI (6). The lo n0 is the central meridian (which takes precedence over the mid-value implied by the -R setting). A simple Eckert VI world map is thus generated by

pscoast -R0/360/-90/90 -JKs180/9i -B60g30/30g15 -Dc -A5000 \
-Gchocolate -SDarkTurquoise -Wthinnest > map.ps

##### Exercises

1. Center the map on Greenwich.
2. Add a map scale with -L.

## Chapter 2
SESSION TWO

### 2.1 General Information

There are 18 GMT programs that directly create (or add overlays to) plots (Table 2.1); the remaining 45 are mostly concerned with data processing. This session will focus on the task of plotting lines, symbols, and text on maps. We will build on the skills we acquired while familiarizing ourselves with the various GMT map projections as well as how to select a data domain and boundary annotations.

Program | Purpose

BASEMAPS

psbasemap | Create an empty basemap frame with optional scale

pscoast | Plot coastlines, filled continents, rivers, and political borders

pslegend | Create legend overlay

POINTS AND LINES

pswiggle | Draw spatial time-series along their (x,y)-tracks

psxy | Plot symbols, polygons, and lines in 2-D

psxyz | Plot symbols, polygons, and lines in 3-D

HISTOGRAMS

pshistogram | Plot a rectangular histogram

psrose | Plot a polar histogram(sector/rose diagram)

CONTOURS

grdcontour | Contouring of 2-D gridded data sets

pscontour | Direct contouring or imaging of xyz data by optimal triangulation

SURFACES

grdimage | Produce color images from 2-D gridded data

grdvector | Plot vector fields from 2-D gridded data

grdview | 3-D perspective imaging of 2-D gridded data

UTILITIES

psclip | Use polygon files to initiate custom clipping paths

psimage | Plot Sun raster files

psmask | Create clipping paths or generate overlay to mask

psscale | Plot gray scale or color scale bar

pstext | Plot text strings on maps

Table 2.1: List of all 1-D and 2-D plotting programs in GMT.

Plotting lines and symbols, psxy is one of the most frequently used programs in GMT. In addition to the common command line switches it has numerous specific options, and expects different file formats depending on what action has been selected. These circumstances make psxy harder to master than most GMT tools. Table 2.2 shows a complete list of the options.

Option | Purpose

-A | Suppress line interpolation along great circles

-Ccpt | Let symbol color be determined from z-values and the cpt file

-E[x|X][y|Y][cap][/pen] | Draw selected error bars with specified attributes

-Gfill | Set color for symbol or fill for polygons

-L | Explicitly close polygons

-N | Do Not clip symbols at map borders

-S[symbol][size] | Select one of several symbols (See Table 2.3 )

-Wpen | Set pen for line or symbol outline

-m[flag] | Multiple segment input data; headers start with flag

Table 2.2: Optional switches in the psxy program.

The symbols can either be transparent (using -W only, not -G) or solid (-G, with optional outline using -W). The -S option takes the code for the desired symbol and optional size information. If no symbol is given it is expected to be given in the last column of each record in the input file. The size is optional since individual sizes for symbols may also be provided by the input data. The main symbols available to us are shown in Table 2.3.

Option | Symbol

-S-size | horizontal dash; size is length of dash

-Sasize | star; size is radius of circumscribing circle

-Sbsize[/base][u] | bar; size is bar width, append u if size is in x-units
| Bar extends from base [0] to the y-value

-Scsize | circle; size is the diameter

-Sdsize | diamond; size is its side

-Se | ellipse; direction (CCW from horizontal), major, and minor axes in inches
| are read from the input file

-SE | ellipse; azimuth (CW from vertical), major, and minor axes in kilometers
| are read from the input file

-Sgsize | octagon; size is its side

-Shsize | hexagon; size is its side

-Sisize | inverted triangle; size is its side

-Sksymbol/size | kustom symbol; size is its side

-Slsize/string[%font] | letter; size is fontsize. Append a letter or text string, and optionally a font

-Snsize | pentagon; size is its side

-Sp | point; no size needed (1 pixel at current resolution is used)

-Srsize | rect, width and height are read from input file

-Sssize | square, size is its side

-Stsize | triangle; size is its side

-Sv[thick/length/width][nnorm] | vector; direction (CCW from horizontal) and length are read from input data
| Optionally, append the thickness of the vector and the width and length of the
| arrow-head. If the nnorm is appended, all vectors whose lengths are less than
| norm will have their attributes scaled by length/norm

-SV[thick/length/width][nnorm] | vector, except azimuth (degrees east of north) is expected instead of direction
| The angle on the map is calculated based on the chosen map projection

-Sw[size | pie wedge; start and stop directions (CCW from horizontal) are read from
| input data

-Sxsize | cross; size is length of crossing lines

-Sysize | vertical dash; size is length of dash

Table 2.3: The symbol option in psxy. Lower case symbols (a, c, d, g, h, i, n, s, t, x) will fit inside a circle of given diameter. Upper case symbols (A, C, D, G, H, I, N, S, T, X) will have area equal to that of a circle of given diameter.

Because some symbols require more input data than others, and because the size of symbols as well as their color can be determined from the input data, the format of data can be confusing. The general format for the input data is (optional items are in brackets []):

x y [ z ] [ size ] [ σx ] [ σy ] [ symbol ]

Thus, the only required input columns are the first two which must contain the longitude and latitude (or x and y). The remaining items apply when one (or more) of the following conditions are met:

1. If you want the color of each symbol to be determined individually, supply a cptfile with the -C option and let the 3rd data column contain the z-values to be used with the cptfile.
2. If you want the size of each symbol to be determined individually, append the size in a separate column.
3. To draw error bars, use the -E option and give one or two additional data columns with the ±dx and ±dy values; the form of -E determines if one (-Ex or -Ey) or two (-Exy) columns are needed. If upper case flags X or Y are given then we will instead draw a “box-and-whisker” symbol and the σx (or σy) must represent 4 columns containing the minimum, the 25 and 75% quartiles, and the maximum value. The given x (or y) coordinate is taken as the 50% quartile (median).
4. If you draw vectors with -Sv (or -SV) then size is actually two columns containing the direction (or azimuth) and length of each vector.
5. If you draw ellipses (-Se) then size is actually three columns containing the direction and the major and minor axes in plot units (with -SE we expect azimuth instead and axes lengths in km).

Before we try some examples we need to review two key switches; they specify pen attributes and symbol or polygon fill. Please consult Chapter 4 in the GMT Technical Reference and Cookbook before experimenting with the examples below.

#### 2.1.1 Examples

We will start off using the file data in your directory. Using the GMT utility minmax we find the extent of the data region:

minmax data

which returns

data: N = 7 <1/5> <1/5>

telling us that the file data has 7 records and gives the minimum and maximum values for the first two columns. Given our knowledge of how to set up linear projections with -R and -JX, try the following:

1. Plot the data as transparent circles of size 0.3 inches.
2. Plot the data as solid white circles instead.
3. Plot the data using 0.5" stars, making them red with a thick (width = 1.5p), dashed pen.

To simply plot the data as a line we choose no symbol and specify a pen thickness instead:

psxy data -R -J -P -B -Wthinner > plot.ps

#### 2.1.2 Exercises

1. Plot the data as a green-blue polygon instead.
2. Try using a predefined pattern.

A common question is : “How can I plot symbols connected by a line with psxy?”. The surprising answer is that we must call psxy twice. While this sounds cumbersome there is a reason for this: Basically, polygons need to be kept in memory since they may need to be clipped, hence computer memory places a limit on how large polygons we may plot. Symbols, on the other hand, can be plotted one at the time so there is no limit to how many symbols one may plot. Therefore, to connect symbols with a line we must use the overlay approach:

psxy data -R -J -B -P -K -Wthinner > plot.ps
psxy data -R -J -O -W -Si0.2i >> plot.ps

Our final psxy example involves a more complicated scenario in which we want to plot the epicenters of several earthquakes over the background of a coastline basemap. We want the symbols to have a size that reflects the magnitude of the earthquakes, and that their color should reflect the depth of the hypocenter. You will find the two files quakes.ngdc and quakes.cpt in your directory. The first few lines in the quakes.ngdc looks like this:

Historical Tsunami Earthquakes from the NGDC Database
Year Mo Da Lat+N Long+E Dep Mag
1987 01 04 49.77 149.29 489 4.1
1987 01 09 39.90 141.68 067 6.8

Thus the file has three header records (including the blank line), but we are only interested in columns 5, 4, 6, and 7. In addition to extract those columns we must also scale the magnitudes into symbols sizes in inches. Given their range it looks like multiplying the magnitude by 0.02 will work well. Reformatting this file to comply with the psxy input format can be done in a number of ways, including manual editing, using MATLAB, a spreadsheet program, or UNIX tools. Here, without further elaboration, we simply use the UNIX tool awk to do the job ($5 refers to the 5’th column etc., and NR is the current record number):

awk ’{if (NR > 3) print $5, $4, $6, 0.02*$7}’ quakes.ngdc > quakes.d

The awk statement is automatically applied to each record, hence the output file quakes.d should now look like this (try it!):

149.29 49.77 489 0.082
141.68 39.90 067 0.136
...etc etc

We will follow conventional color schemes for seismicity and assign red to shallow quakes (depth 0–100 km), green to intermediate quakes (100–300 km), and blue to deep earthquakes (depth > 300 km). The quakes.cpt file establishes the relationship between depth and color:

# color palette for seismicity
#z0 color z1 color
0 red 100 red
100 green 300 green
300 blue 1000 blue

Apart from comment lines (starting with #), each record in the cpt file governs the color of a symbol whose z value falls in the range between z0 and z1. If the colors for the lower and upper levels differ then an intermediate color will be linearly interpolated given the z value. Here, we have chosen constant color intervals.

We may now complete our example using the Mercator projection; we throw in a map scale out of pure generosity:

pscoast -R130/150/35/50 -JM6i -B5 -P -Ggray -Lf134/49/42.5/500 -K > map.ps
psxy -R -J -O -Cquakes.cpt quakes.d -Sci -Wthinnest >> map.ps

where the i appended to the -Sc option ensures that symbols sizes are interpreted to be in inches.

#### 2.1.3 More exercises

1. Select another symbol.
2. Let the deep earthquakes be cyan instead of blue.

### 2.2 Plotting text strings

In many situations we need to annotate plots or maps with text strings; in GMT this is done using pstext. Apart from the common switches, there are 7 options that are particularly useful (Table 2.4).

Option | Purpose

-Cdx/dy | Spacing between text and the text box (see -W)

-Ddx/dy | Offsets the projected location of the strings

-Gfill | Sets the color of the text

-L | Lists the font ids and exits

-N | Deactivates clipping at the borders

-Spen | Selects outline font and sets pen attributes

-W[fill][o[pen]] | Paint the text box; draw the outline if o is appended (also see -C)

Table 2.4: Some of the most frequently used options in pstext.

Figure 2.1: Relationship between the text box and the extra clearance.

The input data to pstext is expected to contain the following information:

x y size angle fontno justify text

The size argument is the font size in points, the angle is the angle (measured counterclockwise) between the text’s baseline and the horizontal, justify indicates which point on the text-string should correspond to the given x, y location, and text is the text string or sentence to plot. Figure 2.2 illustrates these concepts and shows the relevant two-character codes used for justification.

Figure 2.2: Justification (and corresponding character codes) for text strings.

The text string can be one or several words and may include octal codes for special characters and escape-sequences used to select subscripts or symbol fonts. The escape sequences that are recognized by GMT are given in Tables 2.5 and 2.6.

Code | Effect

@̃ | Turns symbol font on or off

@+ | Turns superscript on or off

@- | Turns subscript on or off

@# | Turns small caps on or off

@_ | Turns underline on or off

@%fontno% | Switches to another font; @%% resets to previous font

@:size: | Switches to another font size; @:: resets to previous size

@;color; | Switches to another font color; @;; resets to previous color

@! | Creates one composite character of the next two characters

@@ | Prints the @ sign itself

Table 2.5: GMT text escape sequences.

Note that these escape sequences (as well as octal codes) can be used anywhere in GMT including in arguments to the -B option. A chart of octal codes can be found in Appendix F in the GMT technical reference book. For accented European characters you must set CHAR_ENCODING to ISOLatin1 in your .gmtdefaults4 file.

We will demonstrate pstext with the following script:

cat << EOF | pstext -R0/7/0/5 -Jx1i -P -B1g1 -GDarkOrange | gv -
1 1 30 0 4 BL It’s P@al, not Pal!
1 2 30 0 4 BL Try @%33%ZapfChancery@%% today
1 3 30 0 4 BL @~D@~g@-b@- = 2@~pr@~G@~D@~h.
1 4 30 0 4 BL University of Hawaii at M@!a\225noa
EOF

Here we have used the “here document” notation in UNIX: The < < EOF will treat the following lines as the input file until it detects the word EOF. We pipe the PostScript directly through gv (the – tells gv that piping is happening).

Code | Effect | Code | Effect

@E | Æ | @e | æ

@O | Ø | @o | ø

@A | Å | @a | å

@C | Ç | @c | ç

@N | Ñ | @n | ñ

@U | Ü | @u | ü

@s | ß |  |

Table 2.6: Shortcuts for some European characters.

### 2.3 Exercises

1. At y = 5, add the sentence “z2 = x2 +y2”.
2. At y = 6, add the sentence “It is 80° today”.

## Chapter 3
SESSION THREE

### 3.1 Contouring gridded data sets

GMT comes with several utilities that can create gridded data sets; we will discuss two such programs later this session. First, we will assume that we already have gridded data sets. In the supplemental GMT archive there is a program that serves as a data extractor from several public domain global gridded data sets. Among these data are ETOPO5, crustal ages, gravity and geoid, and DEM for the continental US. Here, we will use grdraster to extract a GMT-ready grid that we will next use for contouring:

grdraster 1 -R-66/-60/30/35 -Gbermuda.nc -V

Here we use the file extension .nc instead of the generic .grd to indicate that this is a netCDF file. It is good form, but not essential, to use .nc for netCDF grids. Using that extension will help other programs installed on your system to recognize these files and might give it an identifiable icon in your file browser. Learn about other programs that read netCDF files at the netCDF website You can find bermuda.nc also in the tutorial directory of you GMT installation. Feel free to open it in any other program and compare results with GMT.

We first use the GMT program grdinfo to see what’s in this file:

grdinfo bermuda.nc

The file contains bathymetry for the Bermuda region and has depth values from -5475 to -89 meters. We want to make a contour map of this data; this is a job for grdcontour. As with previous plot commands we need to set up the map projection with -J. Here, however, we do not have to specify the region since that is by default assumed to be the extent of the grid file. To generate any plot we will in addition need to supply information about which contours to draw. Unfortunately, grdcontour is a complicated program with too many options. We put a positive spin on this situation by touting its flexibility. Here are the most useful options:

Option | Purpose

-Aannot_int | Annotation interval and attributes

-Ccont_int | Contour interval

-Ggap | Controls placement of contour annotations

-Llow/high | Only draw contours within the low to high range

-Qcut | Do not draw contours with fewer than cut points

-Ssmooth | Resample contours every x_inc/smooth increment

-T[+|-][gap/length][:LH] | Draw tick-marks in downhill direction for innermost closed contours

| Add tick spacing and length, and characters to plot at the center of closed contours.

-W[a|c]pen | Set contour and annotation pens

-Zfactor[/offset] | [Subtract offset] and multiply data by factor prior to processing

Table 3.1: The most useful options in grdcontour.

We will first make a plain contour map using 1 km as annotation interval and 250 m as contour interval. We choose a 7-inch-wide Mercator plot and annotate the borders every 2°:

grdcontour bermuda.nc -JM7i -C250 -A1000 -P -B2 | gv -

#### 3.1.1 Exercises

1. Add smoothing with -S4.
2. Try tick all highs and lows with -T.
3. Skip small features with -Q10.
4. Override region using -R-70/-60/25/35.
5. Try another region that clips our data domain.
6. Scale data to km and use the km unit in the annotations.

### 3.2 Gridding of arbitrarily spaced data

Except in the situation above when a grid file is available, we must convert our data to the right format readable by GMT before we can make contour plots and color-coded images. We distinguish between two scenarios:

1. The (x, y, z) data are available on a regular lattice grid.
2. The (x, y, z) data are distributed unevenly in the plane.

The former situation may require a simple reformatting (using xyz2grd), while the latter must be interpolated onto a regular lattice; this process is known as gridding. GMT supports three different approaches to gridding; here, we will briefly discuss the two most common techniques.

All GMT gridding programs have in common the requirement that the user must specify the grid domain and output filename:

-Rxmin/xmax/ymin/ymax | The desired grid extent
-Ixinc[m|c][/yinc[m|c]] | The grid spacing (append m or c for minutes or seconds of arc)
-Ggridfile | The output grid filename

#### 3.2.1 Nearest neighbor gridding

Figure 3.1: Search geometry for nearneighbor.

The GMT program nearneighbor implements a simple “nearest neighbor” averaging operation. It is the preferred way to grid data when the data density is high. nearneighbor is a local procedure which means it will only consider the control data that is close to the desired output grid node. Only data points inside a specified search radius will be used, and we may also impose the condition that each of the n sectors must have at least one data point in order to assign the nodal value. The nodal value is computed as a weighted average of the nearest data point per sector inside the search radius, with each point weighted according to its distance from the node as follows:

z̄ = ∑i=1n ziwi ∑i=1n wi wi = 1+ 9 ri2 R2 -1

The most important switches are listed in Table 3.2.

Option | Purpose

-Sradius[k] | Sets search radius. Append k to indicate radius in kilometers [Default is x-units]

-Eempty | Assign this value to unconstrained nodes [Default is NaN]

-Nsectors | Sector search, indicate number of sectors [Default is 4]

-W | Read relative weights from the 4th column of input data

Table 3.2: Switches used with the nearneighbor program.

We will grid the data in the file ship.xyz which contains ship observations of bathymetry off Baja California. You can find the file in the sub-directory for example 15. We desire to make a 5’ by 5’ grid. Running minmax on the file yields

ship.xyz: N = 82970 <245/254.705> <20/29.99131> <-7708/-9>

so we choose the region accordingly:

nearneighbor -R245/255/20/30 -I5m -S40k -Gship.nc -V ship.xyz

We may get a view of the contour map using

grdcontour ship.nc -JM6i -P -B2 -C250 -A1000 | gv -

Since the grid ship.nc is stored in netCDF format that is supported by a host of other programs, you can try one of those as well on the same grid.

##### Exercises

1. Try using a 100 km search radius and a 10 minute grid spacing.

#### 3.2.2 Gridding with Splines in Tension

As an alternative, we may use a global procedure to grid our data. This approach, implemented in the program surface, represents an improvement over standard minimum curvature algorithms by allowing users to introduce some tension into the surface. Physically, we are trying to force a thin elastic plate to go through all our data points; the values of this surface at the grid points become the gridded data. Mathematically, we want to find the function z(x,y) that satisfies the following constraints:

z(xk,yk) = zk, for all data (xk,yk,zk),k = 1,n (1-t)∇4 z-t∇2 z = 0elsewhere

where t is the “tension”, 0 ≤ t ≤ 1. Basically, as t → 0 we obtain the minimum curvature solution, while as t →∞ we go towards a harmonic solution (which is linear in cross-section). The theory behind all this is quite involved and we do not have the time to explain it all here, please see Smith and Wessel [1990] for details. Some of the most important switches for this program are indicated in Table 3.3 2.

Option | Purpose

-Aaspect | Sets aspect ratio for anisotropic grids.

-Climit | Sets convergence limit. Default is 1/1000 of data range.

-Ttension | Sets the tension [Default is 0]

Table 3.3: Some of the options in surface.

#### 3.2.3 Preprocessing

The surface program assumes that the data have been preprocessed to eliminate aliasing, hence we must ensure that this step is completed prior to gridding. GMT comes with three preprocessors, called blockmean, blockmedian, and blockmode. The first averages values inside the grid-spacing boxes, the second returns median values, wile the latter returns modal values. As a rule of thumb, we use means for most smooth data (such as potential fields) and medians (or modes) for rough, non-Gaussian data (such as topography). In addition to the required -R and -I switches, these preprocessors all take the same options (listed in Table 3.4).

Option | Purpose

-N | Choose pixel node registration [Default is gridline]

-W[i|o] | Append i or o to read or write weights in the 4th column

Table 3.4: Some of the preprocessing options.

With respect to our ship data we preprocess it using the median method:

blockmedian -R245/255/20/30 -I5m -V ship.xyz > ship_5m.xyz

The output data can now be used with surface:

surface ship_5m.xyz -R245/255/20/30 -I5m -Gship.nc -V

If you rerun grdcontour on the new grid file (try it!) you will notice a big difference compared to the grid made by nearneighbor: since surface is a global method it will evaluate the solution at all nodes, even if there are no data constraints. There are numerous options available to us at this point:

1. We can reset all nodes too far from a data constraint to the NaN value.
2. We can pour white paint over those regions where contours are unreliable.
3. We can plot the landmass which will cover most (but not all) of the unconstrained areas.
4. We can set up a clip path so that only the contours in the constrained region will show.

Here we have only time to explore the latter approach. The psmask program can read the same preprocessed data and set up a contour mask based on the data distribution. Once the clip path is activated we can contour the final grid; we finally deactivate the clipping with a second call to psmask. Here’s the recipe:

psmask -R245/255/20/30 -I5m ship_5m.xyz -JM6i -B2 -P -K -V > map.ps
grdcontour ship.nc -J -O -K -C250 -A1000 >> map.ps
psmask -C -O >> map.ps

### 3.3 Exercises

1. Add the continents using any color you want.
2. Color the clip path light gray (use -G in the first psmask call).

## Chapter 4
SESSION FOUR

In our final session we will concentrate on color images and perspective views of gridded data sets. Before we start that discussion we need to cover three important aspects of plotting that must be understood. These are

1. Color tables and pseudo-colors in GMT.
2. Artificial illumination and how it affects colors.
3. Multi-dimensional grids.

### 4.1 Cpt files

The cpt file is discussed in detail in the GMT Technical Reference and Cookbook, Chapter 4. Please review the format before experimenting further.

Cpt files can be created in any number of ways. GMT provides two mechanisms:

1. Create simple, linear color tables given a master color table (several are built-in) and the desired z-values at color boundaries (makecpt)
2. Create color tables based on a master cpt color table and the histogram-equalized distribution of z-values in a gridded data file (grd2cpt)

One can also make these files manually or with awk or other tools. Here we will limit our discussion to makecpt. Its main argument is the name of the master color table (a list is shown if you run the program with no arguments) and the equidistant z-values to go with it. The main options are given below.

Option | Purpose

-C | Set the name of the master cpt file to use

-I | Reverse the sense of the color progression

-V | Run in verbose mode

-Z | Make a continuous rather than discrete table

Table 4.1: Prime options available in makecpt.

To make discrete and continuous color cpt files for data that ranges from -20 to 60, with color changes at every 10, try these two variants:

makecpt -Crainbow -T-20/60/10 > disc.cpt
makecpt -Crainbow -T-20/60/10 -Z > cont.cpt

We can plot these color tables with psscale; the options worth mentioning here are listed in Table 4.2. In addition, the -B option can be used to set the title and unit label (and optionally to set the annotation-, tick-, and grid-line intervals for the colorbars.)

Option | Purpose

-Ccptfile | The required cpt file

-Dxpos/ypos/length/width[h] | Sets the position of the center/left and dimensions of scale bar.

| Append h to get horizontal bar and give center/top instead

-Imax_intensity | Add illumination effects

Table 4.2: The main switches and options in psscale.

psbasemap -R0/8.5/0/11 -Jx1i -P -B0 -K > bar.ps
psscale -D3i/3i/4i/0.5ih -Cdisc.cpt -B:discrete: -O -K >> bar.ps
psscale -D3i/5i/4i/0.5ih -Ccont.cpt -B:continuous: -O -K >> bar.ps
psscale -D3i/7i/4i/0.5ih -Cdisc.cpt -B:discrete: -I0.5 -O -K >> bar.ps
psscale -D3i/9i/4i/0.5ih -Ccont.cpt -B:continuous: -I0.5 -O >> bar.ps

#### 4.1.1 Exercises

1. Redo the makecpt exercise using the master table hot and redo the bar plot.
2. Try specifying -B10g5.

### 4.2 Illumination and intensities

GMT allows for artificial illumination and shading. What this means is that we imagine an artificial sun placed at infinity in some azimuth and elevation position illuminating our surface. The parts of the surface that slope toward the sun should brighten while those sides facing away should become darker; no shadows are cast as a result of topographic undulations.

While it is clear that the actual slopes of the surface and the orientation of the sun enter into these calculations, there is clearly an arbitrary element when the surface is not topographic relief but some other quantity. For instance, what does the slope toward the sun mean if we are plotting a grid of heat flow anomalies? While there are many ways to accomplish what we want, GMT offers a relatively simple way: We may calculate the gradient of the surface in the direction of the sun and normalize these values to fall in the ±1 range; +1 means maximum sun exposure and -1 means complete shade. Although we will not show it here, it should be added that GMT treats the intensities as a separate data set. Thus, while these values are often derived from the relief surface we want to image they could be separately observed quantities such as back-scatter information.

Colors in GMT are specified in the RGB system used for computer screens; it mixes red, green, and blue light to achieve other colors. The RGB system is a Cartesian coordinate system and produces a color cube. For reasons better explained in Appendix I in the Reference book it is difficult to darken and brighten a color based on its RGB values and an alternative coordinate system is used instead; here we use the HSV system. If you hold the color cube so that the black and white corners are along a vertical axis, then the other 6 corners project onto the horizontal plane to form a hexagon; the corners of this hexagon are the primary colors Red, Yellow, Green, Cyan, Blue, and Magenta. The CMY colors are the complimentary colors and are used when paints are mixed to produce a new color (this is how printers operate; they also add pure black (K) to avoid making gray from CMY). In this coordinate system the angle 0–360° is the hue (H); the Saturation and Value are harder to explain. Suffice it to say here that we intend to darken any pure color (on the cube facets) by keeping H fixed and adding black and brighten it by adding white; for interior points in the cube we will add or remove gray. This operation is efficiently done in the HSV coordinate system; hence all GMT shading operations involve translating from RGB to HSV, do the illumination effect, and transform back the modified RGB values.

### 4.3 Color images

Once a cpt file has been made it is relatively straightforward to generate a color image of a gridded data. Here, we will extract a subset of the global 30" DEM (data id 9) from USGS:

grdraster 9 -R-108/-103/35/40 -Gus.nc

You can find the grid us.nc also in the tutorial directory of your GMT installation. Using grdinfo we find that the data ranges from ~1000m to ~4300m so we make a cpt file accordingly:

makecpt -Crainbow -T1000/5000/500 -Z > topo.cpt

Color images are made with grdimage which takes the usual common command options (by default the -R is taken from the data set) and a cptfile; the main other options are

Option | Purpose

-Edpi | Sets the desired resolution of the image [Default is data resolution]

-Iintenfile | Use artificial illumination using intensities from intensfile

-M | Force gray shade using the (television) YIQ conversion

Table 4.3: The main options in grdimage.

We want to make a plain color map with a color bar superimposed above the plot. We try

grdimage us.nc -JM6i -P -B2 -Ctopo.cpt -V -K > topo.ps
psscale -D3i/8.5i/5i/0.25ih -Ctopo.cpt -I0.4 -B/:m: -O >> topo.ps

The plain color map lacks detail and fails to reveal the topographic complexity of this Rocky Mountain region. What it needs is artificial illumination. We want to simulate shading by a sun source in the east, hence we derive the required intensities from the gradients of the topography in the N90°E direction using grdgradient. Other than the required input and output filenames, the available options are

Option | Purpose

-Aazimuth | Azimuthal direction for gradients

-M | Indicates that this is a geographic grid

-N[t|e][norm[/offset]] | Normalize gradients by norm/offset [= 1/0 by default].
| Insert t to normalize by the ta n-1 transformation.
| Insert e to normalize by the cumulative Laplace distribution.

Table 4.4: The grdgradient options.

Figure 4.1 shows that raw slopes from bathymetry tend to be far from normally distributed (left). By using the inverse tangent transformation we can ensure a more uniform distribution (right). The inverse tangent transform simply takes the raw slope estimate (the x value at the arrow) and returns the corresponding inverse tangent value (normalized to fall in the ±1 range; horizontal arrow pointing to the y-value).

Figure 4.1: How the inverse tangent operation works.

Both -Ne and -Nt yield well behaved gradients. Personally, we prefer to use the -Ne option; the value of norm is subjective and you may experiment somewhat in the 0.5–5 range. For our case we choose

grdgradient us.nc -Ne0.8 -A100 -M -Gus_i.nc

Given the cpt file and the two gridded data sets we can create the shaded relief image:

grdimage us.nc -Ius_i.nc -JM6i -P -B2 -Ctopo.cpt -K > topo.ps
psscale -D3i/8.5i/5i/0.25ih -Ctopo.cpt -I0.4 -B/:m: -O >> topo.ps

#### 4.3.1 Exercises

1. Force a gray-shade image.
2. Rerun grdgradient with -N1.

### 4.4 Multi-dimensional maps

Climate data, like ocean temperatures or atmospheric pressure, are often provided as multi-dimensional (3-D, 4-D or 5-D) grids in netCDF format. This section will demonstrate that GMT is able to plot “horizonal” slices (spanning latitude and longitude) of such grids without much effort.

As an example we will download the Seasonal Analysed Mean Temperature from the World Ocean Atlas 1998. The file in question is named otemp.anal1deg.nc.

You can look at the information pertained in this file using the program ncdump and notice that the variable that we want to plot (otemp) is a four-dimensional variable of time, level (i.e., depth), latitude and longitude.

ncdump -h otemp.anal1deg.nc

We will need to make an appropriate color scale, running from -2°C (freezing temperature of salt water) to 30°C (highest likely ocean temperature). We do this as follows:

makecpt -Cno_green -T-2/30/2 > otemp.cpt

Let us focus on the temperatures in Summer (that is the third season, July through September) at sea level (that is the first level). To plot these in a Mollweide projection we use:

grdimage -Rg -JW180/9i ~otemp.anal1deg.nc?otemp[2,0]~ -Cotemp.cpt -Bg30 \
> otemp.ps

The addition ?otemp[2,0] indicates which variable to retrieve from the netCDF file (otemp) and that we need the third time step and first level. The numbering of the time steps and levels starts at zero, therefore [2,0]. Make sure to put the whole file name within quotes since the characters ?, [ and ] have special meaning in Unix.

#### 4.4.1 Exercises

1. Plot the temperatures for Spring at 5000 m depth. (Hint: use ncdump -v level to figure out what level number that is).
2. Include a color scale at the bottom of the plot.

### 4.5 Perspective views

Our final undertaking in this tutorial is to examine three-dimensional perspective views. GMT is currently limited to vantage points at infinity; thus we are unable to do fly-by’s through canyons etc. The GMT module that produces perspective views of gridded data files is grdview. It can make two kinds of plots:

1. Mesh or wire-frame plot (with or without superimposed contours)
2. Color-coded surface (with optional shading, contours, or draping).

Regardless of plot type, some arguments must be specified; these are

1. relief_file; a gridded data set of the surface.
2. -J for the desired map projection.
3. -JZheight for the vertical scaling.
4. -Eazimuth/elevation for vantage point.

In addition, some options may be required:

Option | Purpose

-Ccptfile | The cptfile is required for color -coded surfaces and for contoured mesh plots

-Gdrape_file | Assign colors using drape_file instead of relief_file

-Iintens_file | File with illumination intensities

-Qm | Selects mesh plot

-Qs[m] | Surface plot using polygons; append m to show mesh. This option allows for -W

-Qidpi[g] | Image by scan-line conversion. Specify dpi; append g to force gray-shade image. -B is disabled.

-Wpen | Draw contours on top of surface (except with -Qi)

Table 4.5: The most useful options in grdview.

#### 4.5.1 Mesh-plot

Mesh plots work best on smaller data sets. We again use the small subset of the ETOPO5 data over Bermuda and make a quick-and-dirty cpt file:

grd2cpt bermuda.nc -Cocean > bermuda.cpt

A simple mesh plot can therefore be obtained with

grdview bermuda.nc -JM5i -P -JZ2i -E135/30 -B2 -Cbermuda.cpt > map.ps

##### Exercises

1. Select another vantage point and vertical height.

#### 4.5.2 Color-coded view

We will make a perspective, color-coded view of the US Rockies from the southeast. This is done using

grdview us.nc -JM6i -E135/35 -Qi50 -Ius_i.nc -Ctopo.cpt -V -B2 \
-JZ0.5i > view.ps

This plot is pretty crude since we selected 50 dpi but it is fast to render and allows us to try alternate values for vantage point and scaling. When we settle on the final values we select the appropriate dpi for the final output device and let it rip.

##### Exercises

1. Choose another vantage point and scaling.
2. Redo grdgradient with another illumination direction and replot.
3. Select a higher dpi, e.g., 200.

## Chapter 5
References

1. Smith, W.H.F., and P. Wessel, Gridding with continuous curvature splines in tension, Geophysics, 55, 293–305, 1990.
2. Wessel, P., and W.H.F. Smith, Free software helps map and display data, EOS Trans. AGU, 72, 441, 1991.
3. Wessel, P., and W.H.F. Smith, New version of the Generic Mapping Tools released, EOS Trans. AGU, 76, 329, 1995.
4. Wessel, P., and W.H.F. Smith, A global, self-consistent, hierarchical, high-resolution shoreline database, J. Geophys. Res., 101, 8741–8743, 1996.
5. Wessel, P., and W.H.F. Smith, New, improved version of the Generic Mapping Tools released, EOS Trans. AGU, 79, 579, 1998.
6. Wessel, P., and W.H.F. Smith, The Generic Mapping Tools Technical Reference and Cookbook, Version 4.5.12, pp. 227, 2014.

1 See Wessel and Smith [1996].

2 The -Aoption is necessary for geographic grids since x_inc shrinks with latitude. Rule of thumb: set aspect = cosine of the average latitude.